<?php

/** This codebase seems to be caught in the middle of a database layer rewrite.
 * There's a bunch of database access code stuck in library files, but new database
 * functionality is in the models. I'm intentionally writing new access code in here
 * even though there's a Check library that handles most of what you'd want.
 * -swolf 2023-10-26
 */
class Check extends CI_Model {

    function __construct()
    {
        parent::__construct();
        $this->t = "nagiosna_Checks";
        $this->a = 'nagiosna_ChecksHSALinker';
        $this->u = 'nagiosna_ChecksUsersLinker';
        $this->r = 'nagiosna_ChecksTrapsLinker';
        $this->c = 'nagiosna_ChecksCmdLinker';
    }

    function read_by_associated_path($pid)
    {
        if (empty($pid)) {
            return array();
        }

        if (!is_array($pid)) {
            $pid = array($pid);
        }

        foreach ($pid as $i => $p) {
            $pid[$i] = intval($p);
        }

        $pid_safe = implode(',', $pid);
        $check_select_query = "SELECT * FROM {$this->t} WHERE pid IN ($pid_safe)";
        $result = $this->db->query($check_select_query);
        $check_array = $result->result_array();

        return $check_array;
    }

    function delete($ids)
    {
        if (empty($ids)) {
            return;
        }

        if (!is_array($ids)) {
            $ids = array($ids);
        }
        foreach($ids as $i=>$id) {
            $ids[$i] = intval($id);
        }
        $ids_safe = implode(',', $ids);

        $tables = array($this->t,$this->a,$this->u,$this->r,$this->c);
        foreach ($tables as $table) {
            $query = "DELETE FROM $table WHERE cid IN ($ids_safe)";
            $this->db->query($query);
        }
        // TODO: is there any value in checking this result?
    }
}